function utf8hex(str)
    return "UTF-8:" .. str:gsub('.', function (c)
		return string.format("x%X", string.byte(c))
    end)
end

--[[
---WARNING:
don't forget to install an .ttf font with Unicode support for your language (for example Arial Unicode MS) (standard CS2D font don't support chinese, japanese, thai, korean and some other languages which use non-latin letters or hieroglyphs in their alphabet)
tested on cs2d 1.0.1.2, performance on future versions is not guaranteed

---INSTALLATION:
drop simpleutf8.lua to cs2d/sys/lua folder and dofile it in server.lua	
	dofile("sys/lua/simpleutf8.lua")

---USAGE:

	your_text = "hello привет cześć 你好 Olá 안녕하세요 こんにちは สวัสดี"
	
	print(utf8hex(your_text))
	msg(utf8hex(your_text))
	msg(utf8hex(your_text.."@C"))
	msg(utf8hex("©000255000"..your_text.."@C"))
	msg2(1, utf8hex(your_text))
	msg2(1, utf8hex(your_text.."@C"))
	msg2(1, utf8hex("©000255000"..your_text.."@C"))
	parse(utf8hex('hudtxt 1 "'..your_text..'" 500 400 0 0 20'))
	parse(utf8hex('hudtxt 1 "©000255000'..your_text..'" 500 400 0 0 20'))
	parse(utf8hex('hudtxt2 1 1 "'..your_text..'" 500 400 0 0 20'))
	parse(utf8hex('hudtxt2 1 1 "©000255000'..your_text..'" 500 400 0 0 20'))
	parse(utf8hex("say "..your_text..""))
	parse(utf8hex("sayteam "..your_text..""))
	parse(utf8hex("sv_msg "..your_text..""))
	parse(utf8hex("sv_msg "..your_text.."@C"))
	parse(utf8hex("sv_msg ©000255000"..your_text.."@C"))
	parse(utf8hex("sv_msg2 1 "..your_text..""))
	parse(utf8hex("sv_msg2 1 "..your_text.."@C"))
	parse(utf8hex("sv_msg2 1 ©000255000"..your_text.."@C"))
	
--parse replacement method
	
	_parse = parse
	function parse(cmd, ...)
		_parse(utf8hex(cmd), ...)
	end
	
	parse("sv_msg "..your_text.."")
	parse('hudtxt 1 "'..your_text..'" 500 400 0 0 40')
	

---BUGS:
you can't use ; (semicolon), but it's vanilla cs2d bug/limitation

---EXPLANATION: 
функция конвертирует все символы строки в шестнадцатеричный код, понятный cs2d
"UTF-8:"  ->когда cs2d видит 'UTF-8:' в начале строки, игра понимает, что нужно перевести ее из шестнадцатеричного (hexadecimal) в utf-8; пример: print("UTF-8:xD0xB1") выведет букву "б" в консоль
'.'  ->выполнять для всех символов
'.', function (c) return  ->все символы заменяются на значение, которое возвратит функция для этого символа (с)
x  ->добавляет букву 'x' впереди
%X  ->спецификатор, переводит десятичное в шестнадцатеричное без знака (в верхнем регистре), cs2d регистр не важен, аналог %x
string.byte(c)  ->переводит символ (c) в десятичное
]]